image: openjdk:8-jdk

variables:
  ANDROID_COMPILE_SDK: "28"
  ANDROID_BUILD_TOOLS: "28.0.2"
  ANDROID_SDK_TOOLS:   "4333796"

before_script:
- apt-get --quiet update --yes
- apt-get --quiet install --yes wget tar unzip lib32stdc++6 lib32z1
- wget --quiet --output-document=android-sdk.zip https://dl.google.com/android/repository/sdk-tools-linux-${ANDROID_SDK_TOOLS}.zip
- unzip -d android-sdk-linux android-sdk.zip
- echo y | android-sdk-linux/tools/bin/sdkmanager "platforms;android-${ANDROID_COMPILE_SDK}" >/dev/null
- echo y | android-sdk-linux/tools/bin/sdkmanager "platform-tools" >/dev/null
- echo y | android-sdk-linux/tools/bin/sdkmanager "build-tools;${ANDROID_BUILD_TOOLS}" >/dev/null
- export ANDROID_HOME=$PWD/android-sdk-linux
- export PATH=$PATH:$PWD/android-sdk-linux/platform-tools/
- chmod +x ./gradlew
# temporarily disable checking for EPIPE error and use yes to accept all licenses
- set +o pipefail
- yes | android-sdk-linux/tools/bin/sdkmanager --licenses
- set -o pipefail

stages:
- build
- test
- deploy

lintDebug:
  stage: build
  only:
  - master
  - stage
  - internal
  script:
  - echo "Execute lintDebug"
  - ./gradlew -Pci --console=plain :app:lintDebug -PbuildDir=lint

# 1st step trying to build the project
assembleDebug:
  stage: build
  only:
  - master
  - stage
  - internal
  - merge_requests
  script:
  - echo "Execute assembleDebug"
  - ./gradlew assembleDebug
  artifacts:
    paths:
    - app/build/outputs/

# 2nd execute tests
debugTests:
  stage: test
  only:
  - master
  - stage
  - internal
  - merge_requests
  script:
  - echo "Execute debugTests"
  - ./gradlew -Pci --console=plain :app:testDebug

# 3th step - upload apk to alpha channel
#deploy_alpha:
#  stage: deploy
#  only:
#  - master
#  script:
#  - echo "Deploy to production channel"
#  - ./gradlew clean
#  - ./gradlew build
#  - ./gradlew publishReleaseApk